#include <stdbool.h>

char text[] = "(12+(345+65))*(9+((33-76)/71))";
int position = 0;
bool error = false;

int evaluateNumber(void)
{
  int a = 0;
  bool gotAtLeastOneDigit = false;
  bool done = false;
  while(!done)
  {
     char c = text[position];
     if(c >= '0' && c <= '9')
     {
       gotAtLeastOneDigit = true;
       a = a*10 + c-'0';
       position++;
     }
     else
     {
       done = true;
     }    
  }
  if(!gotAtLeastOneDigit)
  {
    error = true;
  }
  return a;
}

int evaluateOperand(void);

int evaluateExpression(void)
{
  int a = evaluateOperand();
  char c = text[position];
  if(c == 0)
  {
    return a;
  }
  else
  {
    position++;
    int b = evaluateOperand();
    switch(c)
    {
    case '+':
      return a+b;
    case '-':
      return a-b;
    case '*':
      return a*b;
    case '/':
      return a/b;
    default:
      error = true;
      return 0;      
    }
  }
}

int evaluateOperand()
{
  char c = text[position];
  if(c == '(')
  {
    position++;
    int a = evaluateExpression();
    if(text[position] == ')')
    {
      position++;
      return a;
    }
    error = true;
    return 0;
  }
  else
  {
    return evaluateNumber();
  }
}

int main( void )
{
  int a = evaluateExpression();
  if(text[position] != 0)
  {
    error = true;
  }
  
  int b = (12+(345+65))*(9+((33-76)/71)); // zum Vergleich
  
  return 0;
}
